package common;

import java.lang.reflect.Method;
import java.rmi.Remote;
import java.util.HashMap;
import java.util.Map;

public class ReflectionUtility {
	
	static Map<String, Class> primitiveToType = new HashMap();

	public static Class forName(String typeName) {
		try {
		Class retVal = primitiveToType.get(typeName);
		if (retVal == null)
			retVal =  Class.forName(typeName);
		return retVal;
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		
	}
	
	public static boolean isGetter(Method method) {	
		String name = method.getName();
		if (name.startsWith("get") && !name.equals("get")) {
			if (method.getParameterTypes().length == 0 &&
				!method.getReturnType().equals(Void.TYPE))
				return true;
			else
				return false;
		}
		return  false;		
	}
	
	public static boolean isPrimitive(Class aClass) {
		return primitiveToType.values().contains(aClass);
	}
	static {
		primitiveToType.put("int", Integer.TYPE);
		primitiveToType.put("boolean", Boolean.TYPE);
		primitiveToType.put("float", Float.TYPE);
		primitiveToType.put("double", Double.TYPE);
		primitiveToType.put("long", Long.TYPE);
		primitiveToType.put("short", Short.TYPE);
		primitiveToType.put("char", Character.TYPE);
	}
	public static Class getRemoteInterface (Remote remote) {
		Class remoteClass = remote.getClass();
		Class[] interfaces = remoteClass.getInterfaces();
		for (int i = 0; i < interfaces.length; i++) {
			Class anInterface = interfaces[i];
			if (Remote.class.isAssignableFrom(anInterface))
				return anInterface;
		}
		return null;	
	}

}
