package global;

import inputport.datacomm.duplex.DuplexClientInputPort;
import inputport.datacomm.duplex.DuplexServerInputPort;

import inputport.datacomm.simplex.AReceiveMessageForwarderFactory;
import inputport.datacomm.simplex.ASendMessageForwarderFactory;
import inputport.datacomm.simplex.ATrapperSelector;
import inputport.datacomm.simplex.ReceiveTrapper;
import inputport.datacomm.simplex.SendTrapper;
import inputport.datacomm.simplex.TrapperFactory;
import inputport.datacomm.simplex.TrapperSelector;

import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.Map;


public class GlobalState {
	
	static Runnable delayQueueConsumer;
	static Thread delayQueueConsumerThread;
//	static GroupTrapperFactory causalClientObjectMessageFactory = new ACausalClientObjectMessageFactory();
//	static UniToGroupSendTrapperFactory anyCastFactory = new AGetterAnyCastSendForwarderFactory();


	static TrapperSelector<ByteBuffer, ByteBuffer> clientBufferIPTrapperSelector = new ATrapperSelector();
	

	static TrapperSelector<ByteBuffer, ByteBuffer> serverBufferIPTrapperSelector = new ATrapperSelector();
	static TrapperSelector<ByteBuffer, ByteBuffer> clientBufferDuplexIPTrapperSelector = new ATrapperSelector();
	static TrapperSelector<ByteBuffer, ByteBuffer> serverBufferDuplexIPTrapperSelector = new ATrapperSelector();
	
	static TrapperSelector<Object, ByteBuffer> objectTranslatingIPTrapperSelector = new ATrapperSelector();
	static TrapperSelector<Object, Object> clientObjectForwardingIPTrapperSelector = new ATrapperSelector();
//	static GroupTrapperSelector<Object, Object> serverObjectForwardingIPTrapperSelector = new AGroupTrapperSelector();

	static TrapperSelector<Object, Object> clientObjectDuplexIPTrapperSelector = new ATrapperSelector();
	static TrapperSelector<Object, Object> serverObjectDuplexIPTrapperSelector = new ATrapperSelector();
	static TrapperSelector<Object, Object> clientRelayingObjectDuplexIPTrapperSelector = new ATrapperSelector();

	
	
	static TrapperSelector<ByteBuffer, ByteBuffer> bufferDuplexSPFP2PTrapperSelector = new ATrapperSelector();
	static TrapperSelector<Object, Object> objectDuplexSPRelayedTrapperSelector = new ATrapperSelector();

	
	static TrapperSelector<Object, Object> sessionObjectDuplexForwardingIPTrapperSelector = new ATrapperSelector();
	
//	static GroupTrapperSelector<Object, ByteBuffer> sessionObjectGroupTranslatingIPTrapperSelector = new AGroupTrapperSelector();
	
	static TrapperSelector replicatedServerDuplexObjectTrapperSelector = new ATrapperSelector();
	
	
	

//  this is a group to group object pipe, so dont need other trappers
//	static TrapperSelector<Object, Object> sessionGroupToUniSendObjectTrapperSelector = new ATrapperSelector();
	
	



	
	
	

	
	
	
	
	public static void supportSingleResponse(TrapperFactory trapperFactory, DuplexServerInputPort aServerPort) {
//		TrapperFactory trapperFactory = new ASingleResponseServerTrapperFactory();
		SendTrapper oldSendTrapper = aServerPort.getSendTrapper();
		ReceiveTrapper oldReceiveTrapper = aServerPort.getReceiveTrapper();
		SendTrapper sendTrapper = trapperFactory.createSendTrapper(aServerPort, oldSendTrapper);
		ReceiveTrapper receiveTrapper = trapperFactory.createReceiveTrapper(aServerPort, oldReceiveTrapper);
		aServerPort.setSendTrapper(sendTrapper);
		aServerPort.setReceiveTrapper(receiveTrapper);
	}
	
	

	
	public static Thread getDelayQueueConsumerThread() {
		return delayQueueConsumerThread;
	}
	
	
	


	public static TrapperSelector<ByteBuffer, ByteBuffer> getClientBufferDuplexIPTrapperSelector() {
		return clientBufferDuplexIPTrapperSelector;
	}

	public static void setClientBufferDuplexIPTrapperSelector(
			TrapperSelector<ByteBuffer, ByteBuffer> clientBufferDuplexIPTrapperSelector) {
		GlobalState.clientBufferDuplexIPTrapperSelector = clientBufferDuplexIPTrapperSelector;
	}

	public static TrapperSelector<ByteBuffer, ByteBuffer> getServerBufferDuplexIPTrapperSelector() {
		return serverBufferDuplexIPTrapperSelector;
	}

	public static void setServerBufferDuplexIPTrapperSelector(
			TrapperSelector<ByteBuffer, ByteBuffer> serverBufferDuplexIPTrapperSelector) {
		GlobalState.serverBufferDuplexIPTrapperSelector = serverBufferDuplexIPTrapperSelector;
	}

	

	

	public static TrapperSelector<ByteBuffer, ByteBuffer> getBufferDuplexSPFP2PTrapperSelector() {
		return bufferDuplexSPFP2PTrapperSelector;
	}

	public static void setBufferDuplexSPFP2PTrapperSelector(
			TrapperSelector<ByteBuffer, ByteBuffer> bufferDuplexSPFP2PTrapperSelector) {
		GlobalState.bufferDuplexSPFP2PTrapperSelector = bufferDuplexSPFP2PTrapperSelector;
	}

	public static TrapperSelector<Object, Object> getObjectDuplexSPRelayedTrapperSelector() {
		return objectDuplexSPRelayedTrapperSelector;
	}

	public static void setObjectDuplexSPRelayedTrapperSelector(
			TrapperSelector<Object, Object> objectDuplexSPRelayedTrapperSelector) {
		GlobalState.objectDuplexSPRelayedTrapperSelector = objectDuplexSPRelayedTrapperSelector;
	}





	public static TrapperSelector<Object, Object> getClientObjectDuplexIPTrapperSelector() {
		return clientObjectDuplexIPTrapperSelector;
	}

	public static void setClientObjectDuplexIPTrapperSelector(
			TrapperSelector<Object, Object> clientObjectDuplexIPTrapperSelector) {
		GlobalState.clientObjectDuplexIPTrapperSelector = clientObjectDuplexIPTrapperSelector;
	}

	public static TrapperSelector<Object, Object> getServerObjectDuplexIPTrapperSelector() {
		return serverObjectDuplexIPTrapperSelector;
	}

	public static void setServerObjectDuplexIPTrapperSelector(
			TrapperSelector<Object, Object> serverObjectDuplexIPTrapperSelector) {
		GlobalState.serverObjectDuplexIPTrapperSelector = serverObjectDuplexIPTrapperSelector;
	}

	public static TrapperSelector<Object, ByteBuffer> getObjectTranslatingIPTrapperSelector() {
		return objectTranslatingIPTrapperSelector;
	}

	public static void setObjectTranslatingIPTrapperSelector(
			TrapperSelector<Object, ByteBuffer> clientObjectTranslatingIPTrapperSelector) {
		GlobalState.objectTranslatingIPTrapperSelector = clientObjectTranslatingIPTrapperSelector;
	}

//	public static TrapperSelector<Object, ByteBuffer> getServerObjectTranslatingIPTrapperSelector() {
//		return serverObjectTranslatingIPTrapperSelector;
//	}
//
//	public static void setServerObjectTranslatingIPTrapperSelector(
//			TrapperSelector<Object, ByteBuffer> serverObjectTranslatingIPTrapperSelector) {
//		GlobalState.serverObjectTranslatingIPTrapperSelector = serverObjectTranslatingIPTrapperSelector;
//	}

	public static TrapperSelector<Object, Object> getClientObjectForwardingIPTrapperSelector() {
		return clientObjectForwardingIPTrapperSelector;
	}

	public static void setClientObjectForwardingIPTrapperSelector(
			TrapperSelector<Object, Object> clientObjectForwardingIPTrapperSelector) {
		GlobalState.clientObjectForwardingIPTrapperSelector = clientObjectForwardingIPTrapperSelector;
	}

//	public static TrapperSelector<Object, Object> getServerObjectForwardingIPTrapperSelector() {
//		return serverObjectForwardingIPTrapperSelector;
//	}
//
//	public static void setServerObjectForwardingIPTrapperSelector(
//			TrapperSelector<Object, Object> serverObjectForwardingIPTrapperSelector) {
//		GlobalState.serverObjectForwardingIPTrapperSelector = serverObjectForwardingIPTrapperSelector;
//	}
	
	
	public static TrapperSelector<Object, Object> getSessionObjectDuplexForwardingIPTrapperSelector() {
		return sessionObjectDuplexForwardingIPTrapperSelector;
	}

	public static void setSessionObjectDuplexForwardingIPTrapperSelector(
			TrapperSelector<Object, Object> sessionObjectDuplexForwardingIPTrapperSelector) {
		GlobalState.sessionObjectDuplexForwardingIPTrapperSelector = sessionObjectDuplexForwardingIPTrapperSelector;
	}

//	public static GroupTrapperSelector<Object, ByteBuffer> getSessionObjectGroupTranslatingIPTrapperSelector() {
//		return sessionObjectGroupTranslatingIPTrapperSelector;
//	}
//
//	public static void setSessionObjectGroupTranslatingIPTrapperSelector(
//			GroupTrapperSelector<Object, ByteBuffer> objectGroupTranslatingSessionIPTrapperSelector) {
//		GlobalState.sessionObjectGroupTranslatingIPTrapperSelector = objectGroupTranslatingSessionIPTrapperSelector;
//	}

	

//	public static TrapperSelector<Object, Object> getSessionGroupToUniSendObjectTrapperSelector() {
//		return sessionGroupToUniSendObjectTrapperSelector;
//	}
//
//	public static void setSessionGroupToUniSendObjectTrapperSelector(
//			TrapperSelector<Object, Object> unOptimizedObjectGroupSessionIPForwardingTrapperSelector) {
//		GlobalState.sessionGroupToUniSendObjectTrapperSelector = unOptimizedObjectGroupSessionIPForwardingTrapperSelector;
//	}
	
	
	public static TrapperSelector<ByteBuffer, ByteBuffer> getSimplexBufferClientIPTrapperSelector() {
		return clientBufferIPTrapperSelector;
	}

	public static void setSimplexBufferClientIPTrapperSelector(
			TrapperSelector<ByteBuffer, ByteBuffer> clientBufferIPTrapperSelector) {
		GlobalState.clientBufferIPTrapperSelector = clientBufferIPTrapperSelector;
	}

	public static TrapperSelector<ByteBuffer, ByteBuffer> getSimplexBufferServerIPTrapperSelector() {
		return serverBufferIPTrapperSelector;
	}

	public static void setSimplexBufferServerIPTrapperSelector(
			TrapperSelector<ByteBuffer, ByteBuffer> serverBufferIPTrapperSelector) {
		GlobalState.serverBufferIPTrapperSelector = serverBufferIPTrapperSelector;
	}



	

	public static TrapperSelector<Object, Object> getClientRelayingObjectDuplexIPTrapperSelector() {
		return clientRelayingObjectDuplexIPTrapperSelector;
	}

	public static void setClientRelayingObjectDuplexIPTrapperSelector(
			TrapperSelector<Object, Object> clientRelayingObjectDuplexIPTrapperSelector) {
		GlobalState.clientRelayingObjectDuplexIPTrapperSelector = clientRelayingObjectDuplexIPTrapperSelector;
	}



	public static TrapperSelector<Object, Object> getReplicatedServerDuplexObjectTrapperSelector() {
		return replicatedServerDuplexObjectTrapperSelector;
	}

	public static void setReplicatedServerDuplexObjectTrapperSelector(
			TrapperSelector<Object, Object> replicatedServerObjectDuplexTrapperSelector) {
		GlobalState.replicatedServerDuplexObjectTrapperSelector = replicatedServerObjectDuplexTrapperSelector;
	}




	static {
//		delayQueueConsumer = new ADelayQueueConsumer(delayQueue);		
//		delayQueueConsumerThread = new Thread(delayQueueConsumer);
//		delayQueueConsumerThread.start();
	}	

}
