package inputport;


import java.util.ArrayList;
import java.util.List;

import common.Tracer;



public class AConnectRegistrarAndNotifier implements ConnectionRegistrarAndNotifier {
	List<ConnectionListener> portConnectListeners = new ArrayList();
	@Override
	public void addConnectionListener(ConnectionListener portConnectListener) {
		portConnectListeners.add(portConnectListener);		
	}
	@Override
	public void removeConnectionListener(ConnectionListener portConnectListener) {
		portConnectListeners.remove(portConnectListener);		
	}
	@Override
	public void notifyConnect (String remoteEnd) {
		Tracer.info(this, "Notifying connect to:" + remoteEnd);
		for (ConnectionListener portConnectListener:portConnectListeners)
			portConnectListener.connected(remoteEnd);		
	}
	@Override
	public void notifyConnectFailure (String remoteEnd, String message) {
		for (ConnectionListener portConnectListener:portConnectListeners)
			portConnectListener.notConnected(remoteEnd, message);		
	}
	@Override
	public void notifyDisconnect (String aRemoteEnd, boolean anExplcitClose, String aCloseReason) {
		for (ConnectionListener portConnectListener:portConnectListeners)
			portConnectListener.disconnected(aRemoteEnd, anExplcitClose, aCloseReason);		
	}
}
