package inputport.datacomm.duplex.buffer;

import inputport.datacomm.simplex.UniNamingSender;

import java.nio.ByteBuffer;

import common.Tracer;
public class AServerChannelSendBufferForwarder<RequestChannelType, ChannelType>  implements UniNamingSender<ByteBuffer>{
	DuplexServerInputPortDriver<RequestChannelType, ChannelType> duplexServerInputDriver;
	BufferGenericDuplexServerInputPort<RequestChannelType, ChannelType> bufferDuplexServerInputPort;
	public AServerChannelSendBufferForwarder(DuplexServerInputPortDriver<RequestChannelType, ChannelType> aDuplexServerInputDriver,
			BufferGenericDuplexServerInputPort<RequestChannelType, ChannelType> aBufferDuplexServerInputPort) {
		duplexServerInputDriver = aDuplexServerInputDriver;
		bufferDuplexServerInputPort = aBufferDuplexServerInputPort;
	}

	@Override
	public void send(String remoteName, ByteBuffer message) {

		Tracer.info(this, "Forwarding server channel buffer " + message + " to name: " + remoteName );
		duplexServerInputDriver.send(remoteName, message);
	}

}
