package inputport.datacomm.duplex.buffer.example;

import inputport.datacomm.duplex.DuplexServerInputPort;
import inputport.datacomm.duplex.buffer.BufferDuplexInputPortSelector;
import inputport.datacomm.simplex.buffer.ASendRegistrarAndNotifier;
import inputport.datacomm.simplex.buffer.example.ATracingSendListener;
import inputport.datacomm.simplex.buffer.example.AnEchoingReceiveListener;

import java.nio.ByteBuffer;

import common.Tracer;

public class AServerDuplexBufferInputPortLauncher extends ADuplexBufferInputPortLauncher {
	public static void main (String[] args) {
		setTracing();
		Tracer.setKeyWordStatus(ASendRegistrarAndNotifier.class.getPackage().getName(), false);
		DuplexServerInputPort<ByteBuffer> aServerInputPort = 
			BufferDuplexInputPortSelector.createDuplexServerInputPort(
				SERVER_PORT, 
				SERVER_NAME);
		addListeners(aServerInputPort);	
		aServerInputPort.connect();		
	}	
	public static void addListeners(DuplexServerInputPort<ByteBuffer> aServerInputPort) {
		aServerInputPort.addConnectionListener(
			new ASendingConnectionListener(aServerInputPort));
		aServerInputPort.addReceiveListener(
			new AnEchoingReceiveListener(aServerInputPort));
		aServerInputPort.addSendListener(new ATracingSendListener(aServerInputPort));
	}
}
