package inputport.datacomm.duplex.buffer.nio;

import inputport.datacomm.duplex.DuplexClientInputPort;
import inputport.datacomm.duplex.DuplexInputPortFactory;
import inputport.datacomm.duplex.DuplexServerInputPort;
import inputport.datacomm.duplex.buffer.AGeneriDuplexBufferServerInputPort;
import inputport.datacomm.duplex.buffer.AGenericDuplexBufferClientInputPort;
import inputport.datacomm.duplex.buffer.BufferGenericDuplexClientInputPort;
import inputport.datacomm.duplex.buffer.BufferGenericDuplexServerInputPort;
import inputport.datacomm.duplex.buffer.DuplexClientInputPortDriver;
import inputport.datacomm.duplex.buffer.DuplexServerInputPortDriver;
import inputport.datacomm.simplex.buffer.nio.ASelectionManagerCreator;

import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;

import common.Tracer;

public class AnNIODuplexBufferInputPortFactory extends ASelectionManagerCreator implements DuplexInputPortFactory {

	@Override
	public DuplexServerInputPort createDuplexServerInputPort(String theServerId,
			String theServerName) {
		Tracer.info(this, "Creating and linking NIO duplex server skeleton and driver and selecting thread");
		BufferGenericDuplexServerInputPort<ServerSocketChannel, SocketChannel> skeleton = new AGeneriDuplexBufferServerInputPort(theServerName, theServerId);
		maybeCreateSelectionManager();
		DuplexServerInputPortDriver<ServerSocketChannel,SocketChannel> driver = new AnNIODuplexBufferServerInputPortDriver(selectingRunnable, theServerId);
		skeleton.setDriver(driver);
		driver.setSkeleton(skeleton);
		return skeleton;
	}
	@Override
	public DuplexClientInputPort createDuplexClientInputPort(String theServerHost,
			String theServerId, String aServerName, String theClientName) {
		Tracer.info(this, "Creating and linking NIO duplex client skeleton and driver and selecting thread");
		BufferGenericDuplexClientInputPort skeleton = new AGenericDuplexBufferClientInputPort(theServerHost, theServerId, aServerName, theClientName);
		maybeCreateSelectionManager();
		DuplexClientInputPortDriver<SocketChannel> implementation = new AnNIODuplexBufferClientInputPortDriver(selectingRunnable, theServerHost, theServerId, aServerName);
		skeleton.setDriver(implementation);
		implementation.setSkeleton(skeleton);
//		return new AMonolithicNIOClientInputPort(selectingRunnable, theServerHost, theServerId, theClientName);
		return skeleton;
	}
}
