package inputport.datacomm.simplex.buffer;

import inputport.InputPort;
import inputport.datacomm.simplex.UniNamingSender;

import java.nio.ByteBuffer;

import common.Tracer;

public class AClientChannelSendBufferForwarder<ChannelType>  implements UniNamingSender<ByteBuffer>{
	SimplexBufferClientInputPortDriver<ChannelType> clientInputDriver;
	public AClientChannelSendBufferForwarder(InputPort anInputPort, SimplexBufferClientInputPortDriver<ChannelType> aClientInputDriver) {
		clientInputDriver = aClientInputDriver;
	}
	@Override
	public void send(String remoteName, ByteBuffer message) {
		Tracer.info(this, "Forwarding client channel message: " + message + " to:" + remoteName );
		clientInputDriver.send(remoteName, message);
	}
}
