package inputport.datacomm.simplex.buffer.example;

import inputport.datacomm.simplex.SimplexClientInputPort;
import inputport.datacomm.simplex.buffer.BufferSimplexInputPortSelector;

import java.nio.ByteBuffer;
import java.util.Scanner;




public class AClientSimplexBufferInputPortLauncher extends ASimplexBufferInputPortLauncher{
	public static final String SERVER_HOST = "localhost";
	public static void launch (String clientName) {
		setTracing();
		SimplexClientInputPort<ByteBuffer> aClientInputPort = 
			BufferSimplexInputPortSelector.createClientSimplexInputPort(
				SERVER_HOST, SERVER_PORT, SERVER_NAME, 	clientName);
		addListeners(aClientInputPort);
		aClientInputPort.connect();
		processInput(aClientInputPort);		
	}
	public static void addListeners(SimplexClientInputPort<ByteBuffer> aClientInputPort) {
		aClientInputPort.addConnectionListener(
			new ATracingConnectionListener(aClientInputPort));
		aClientInputPort.addSendListener(
				new ATracingSendListener(aClientInputPort));
	}
	public static void processInput (SimplexClientInputPort<ByteBuffer> aClientInputPort) {
		String stringMessage;
		ByteBuffer message;
		Scanner in = new Scanner(System.in);	
		while (true) {
			System.out.println("Please enter message:");
		    stringMessage  = in.nextLine();
		    message =  ByteBuffer.wrap(stringMessage.getBytes());	
			aClientInputPort.send(message);
		}
	}
}
