package inputport.datacomm.simplex.buffer.example;

import inputport.datacomm.simplex.SimplexServerInputPort;
import inputport.datacomm.simplex.buffer.AGenericSimplexBufferClientInputPort;
import inputport.datacomm.simplex.buffer.ASendRegistrarAndNotifier;
import inputport.datacomm.simplex.buffer.BufferSimplexInputPortSelector;
import inputport.datacomm.simplex.buffer.nio.AnNIOSimplexBufferClientInputPortDriver;

import java.nio.ByteBuffer;

import common.Tracer;

public class AServerSimplexBufferInputPortLauncher extends ASimplexBufferInputPortLauncher {
	public static void main (String[] args) {
		setTracing();
		SimplexServerInputPort<ByteBuffer> aServerInputPort = 
			BufferSimplexInputPortSelector.createServerSimplexInputPort(
				SERVER_PORT, 
				SERVER_NAME);
		addListeners(aServerInputPort);	
		aServerInputPort.connect();		
	}	
	public static void addListeners(SimplexServerInputPort<ByteBuffer> aServerInputPort) {
		aServerInputPort.addConnectionListener(
			new ATracingConnectionListener(aServerInputPort));
		aServerInputPort.addReceiveListener(
			new AnEchoingReceiveListener(aServerInputPort));		
	}
}
