package inputport.datacomm.simplex.buffer.example;


import inputport.ConnectionListener;
import inputport.InputPort;


public class ATracingConnectionListener implements  ConnectionListener {
	InputPort inputPort;
	public ATracingConnectionListener(InputPort anInputPort) {
		inputPort = anInputPort;		
	}
	@Override
	public void disconnected(String aRemoteEnd, boolean anExplicitClose, String aSystemMessage) {
		System.out.println(inputPort.getLocalName() + "<-->" + aRemoteEnd + " (Closed)");
		if (anExplicitClose) {
			System.out.println("Explanation: Explicit disconnect");
		} else {
			System.out.println("Explanation: " + aSystemMessage);
		}
	}
	@Override
	public void connected(String aRemoteEnd) {
		System.out.println(inputPort.getLocalName() + "<-->" + aRemoteEnd + " (Opened)");		
	}
	@Override
	public void notConnected(String aRemoteEnd, String aMessage) {
		System.out.println(inputPort.getLocalName() + "<-->" + aRemoteEnd + " (Could not connect)");		
	}
}
