package inputport.datacomm.simplex.buffer.nio;

import java.nio.ByteBuffer;
import java.nio.channels.SocketChannel;

import common.Tracer;


public class ABufferedHeaderWrite extends ABufferedWrite implements BufferedHeaderWrite {
	public static final int BYTES_IN_INT =  Integer.SIZE/Byte.SIZE;
	//MessageSelectingRunnable messageSelectingRunnable;
	public ABufferedHeaderWrite(MessagingSelectingRunnable theMessageSelectingRunnable,
			SocketChannel theSocketChannel, 
			SocketChannelWriteListener theWriteListener,
			SocketChannelCloseListener theCloseListener) {
		super(theMessageSelectingRunnable, theSocketChannel, 
				ByteBuffer.allocate(AScatterGatherSelectionManager.BYTES_IN_INT), 
				theWriteListener, theCloseListener);
		//messageSelectingRunnable = theMessageSelectingRunnable;
		//messageSelectingRunnable.add(this);		
	}
	@Override
	public void makeHeaderFor (BufferedWrite theBufferedWrite) {
		ByteBuffer byteBuffer = theBufferedWrite.getWriteBuffer();
		socketChannel = theBufferedWrite.getSocketChannel();
		//writeBuffer.reset();
		writeBuffer.clear();
		writeBuffer.putInt(byteBuffer.limit());
		writeBuffer.rewind();
	}
	@Override
	public boolean doWrite() {
		boolean successful = super.doWrite();
		if (successful) {
			//writeBuffer.clear();
			((MessagingSelectingRunnable) selectingRunnable).add(this);
		} else {
			Tracer.info(this, "unsuccessful write");
		}
		return successful;
	}
	static {
		nextWriteId = - ASelectionManager.MAX_BUFFERS;
	}
}
