package inputport.datacomm.simplex.buffer.nio;

import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;

import common.Tracer;


public class ABufferedWrite implements BufferedWrite  {
	SocketChannel socketChannel;
	ByteBuffer writeBuffer;
	SocketChannelWriteListener writeListener;
	SocketChannelCloseListener closeListener;
	SelectionManager selectingRunnable;
	static int nextWriteId = 0;
	int writeId;
	public ABufferedWrite (SelectionManager aSelectingRunnable, SocketChannel  aSocketChannel, ByteBuffer aWriteBuffer, 
				SocketChannelWriteListener theWriteListener, SocketChannelCloseListener aCloseListener) {
		socketChannel = aSocketChannel;
//		writeBuffer = theWriteBuffer.duplicate();
		writeBuffer = aWriteBuffer;
		writeListener = theWriteListener;
		closeListener = aCloseListener;
		selectingRunnable = aSelectingRunnable;
		writeId = nextWriteId;
//		Tracer.info(this, "ABufferedWrite with id:" + writeId + " contents:" + writeBuffer);
		nextWriteId++;
	}	
	@Override
	public SocketChannel getSocketChannel() {
		return socketChannel;
	}
	@Override
	public void setSocketChannel(SocketChannel theSocketChannel) {
		socketChannel = theSocketChannel;
	}	
	@Override
	public ByteBuffer getWriteBuffer() {
		return writeBuffer;
	}
	@Override
	public boolean doWrite() {
		// whjy are we guaranteed connected?
//		if (!socketChannel.isConnected())
//			return false;
		try {
//			byte[] prefixBytes = new byte[2];
//			byte[] suffixBytes = new byte[writeBuffer.limit() - 2];
//			writeBuffer.get(prefixBytes);
//			writeBuffer.get(suffixBytes);
//			ByteBuffer prefixBuffer = ByteBuffer.wrap(prefixBytes);
//			writeBuffer = ByteBuffer.wrap(suffixBytes);
//			socketChannel.write(prefixBuffer);
//			String writeBufferToString = writeBuffer.toString();
//			Message.info("writing to channel " + socketChannel + " buffer:" + getId() + " with contents" + writeBuffer);
			socketChannel.write(writeBuffer);
			if (writeBuffer.remaining() > 0) {
				SelectionKey selectionKey = socketChannel.keyFor(selectingRunnable.getSelector());
				selectionKey.interestOps(SelectionKey.OP_WRITE);
//				theSelectingRunnable.putBufferedWrite(this);
				return false;
			}
			writeBuffer.flip();
			Tracer.info(this, "written to channel" + socketChannel + " flipped buffer:" + getId() + " with contents" + writeBuffer.toString());
//			Tracer.info(this, "flipping buffer for reading by write listeners:" + writeBuffer.toString());
			if (writeListener != null)
				writeListener.written(socketChannel, writeBuffer, getId());
			Tracer.info(this, "notified listeners about write");

			return true;
			
		} catch (Exception e) {
			e.printStackTrace();
			closeListener.closed(socketChannel, e);
			return false;
		}
	}
	@Override
	public int getId() {
		return writeId;
	}
	
}
