package inputport.datacomm.simplex.buffer.nio;

import java.net.InetAddress;
import java.nio.channels.SelectableChannel;
import java.nio.channels.SelectionKey;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;

import common.Tracer;

public class AnAcceptRequestResponse implements SocketChannelAcceptRequestResponse {
	InetAddress serverHost;
	SocketChannelAcceptListener listener;
	int port;
	int newOps;
	ServerSocketChannel serverSocketChannel;
	SelectionManager selectingRunnable;
	public AnAcceptRequestResponse(SelectionManager theSelectingRunnable, ServerSocketChannel theSocketChannel,  SocketChannelAcceptListener theListener) {
		listener = theListener;
		serverSocketChannel = theSocketChannel;
		selectingRunnable = theSelectingRunnable;
	}	
	public InetAddress getServerHost() {
		return serverHost;
	}
	public int getPort() {
		return port;
	}
	@Override
	public SocketChannelAcceptListener getListener() {
		return listener;
	}
	@Override
	public boolean makeRequest() {
		try {
			Tracer.info(this, "Regisering  accept op for channel:" + serverSocketChannel);
			serverSocketChannel.register(selectingRunnable.getSelector(), SelectionKey.OP_ACCEPT);
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
	}
	@Override
	public void giveResponse() {
		try {
			SocketChannel newSocketChannel = serverSocketChannel.accept();
			newSocketChannel.configureBlocking(false);	
			newSocketChannel.register(selectingRunnable.getSelector(), SelectionKey.OP_READ);
			if (listener != null)
				listener.socketChannelAccepted(serverSocketChannel, newSocketChannel);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	@Override
	public SelectableChannel getChannel() {
		return serverSocketChannel;
	}
//	@Override
//	public SelectingRunnable getSelectingRunnable() {
//		return getSelectingRunnable();
//	}
}
