package inputport.datacomm.simplex.buffer.nio;

import inputport.datacomm.simplex.SimplexClientInputPort;
import inputport.datacomm.simplex.SimplexInputPortFactory;
import inputport.datacomm.simplex.SimplexServerInputPort;
import inputport.datacomm.simplex.buffer.AGenericSimplexBufferClientInputPort;
import inputport.datacomm.simplex.buffer.AGenericSimplexBufferServerInputPort;
import inputport.datacomm.simplex.buffer.GenericSimplexClientInputPort;
import inputport.datacomm.simplex.buffer.GenericSimplexServerInputPort;
import inputport.datacomm.simplex.buffer.SimplexBufferClientInputPortDriver;
import inputport.datacomm.simplex.buffer.SimplexBufferServerInputPortDriver;

import java.nio.ByteBuffer;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;

import common.Tracer;

public class AnNIOSimplexBufferInputPortFactory extends ASelectionManagerCreator implements SimplexInputPortFactory<ByteBuffer> {

	@Override
	public SimplexServerInputPort<ByteBuffer> createSimplexServerInputPort(String theServerId,
			String theServerName) {	
		Tracer.info(this, "Creating and linking NIO simplex server skeleton and driver");
		GenericSimplexServerInputPort<ServerSocketChannel, SocketChannel> skeleton = new AGenericSimplexBufferServerInputPort(theServerName, theServerId);
		maybeCreateSelectionManager();
		SimplexBufferServerInputPortDriver<ServerSocketChannel, SocketChannel> driver = new AnNIOSimplexBufferServerInpuPorttDriver(selectingRunnable, theServerId);
		skeleton.setDriver(driver);
		driver.setSkeleton(skeleton);
		return skeleton;
	}
	@Override
	public SimplexClientInputPort<ByteBuffer> createSimplexClientInputPort(String theServerHost,
			String theServerId, String aServerName, String theClientName) {
		Tracer.info(this, "Creating and linking simplex client skeleton and driver");
		maybeCreateSelectionManager();
		GenericSimplexClientInputPort skeleton = new AGenericSimplexBufferClientInputPort(theServerHost, theServerId, aServerName, theClientName);
		SimplexBufferClientInputPortDriver<SocketChannel> implementation = new AnNIOSimplexBufferClientInputPortDriver(selectingRunnable, theServerHost, theServerId, aServerName);
		skeleton.setDriver(implementation);
		implementation.setSkeleton(skeleton);
		return skeleton;
	}
}
